#  fsysc.defn.tcl

proc {Add_FAIR SYSC_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name bVME RAM             "-a$A32addrbase -w32 -o0x0 -pro -d32 -zx -l64"

   define-vme-register $name xVME FREQU           "-a$A32addrbase -w32 -o0x100000 -pro -d32 -zd"
   define-vme-register $name xVME MUX             "-a$A32addrbase -w32 -o0x100000 -pwo -d32 -zd"
   define-vme-register $name xVME NET             "-a$A32addrbase -w32 -o0x100004 -prw -d32 -zx"
   define-vme-register $name xVME DNET            "-a$A32addrbase -w32 -o0x100008 -pro -d32 -zx"
   define-vme-register $name xVME DELR            "-a$A32addrbase -w32 -o0x100008 -pwo -d32 -zd"
   define-vme-register $name xVME ADMB1           "-a$A32addrbase -w32 -o0x10000c -pro -d32 -zx"
   define-vme-register $name xVME ADMB2           "-a$A32addrbase -w32 -o0x100010 -pro -d32 -zx"
   define-vme-register $name xVME THREB1          "-a$A32addrbase -w32 -o0x10000c -pwo -d32 -zx"
   define-vme-register $name xVME THREB2          "-a$A32addrbase -w32 -o0x100010 -pwo -d32 -zx"
   define-vme-register $name xVME CTRL            "-a$A32addrbase -w32 -o0x100014 -prw -d32 -zd"
   define-vme-register $name xVME STR             "-a$A32addrbase -w32 -o0x10001c -prw -d32 -zx"
}


proc {FAIR SYSC_DAQ-reset} {args} {
#   FAIR system
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

#      Offline the module - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.STR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

#    initialise
    initialise-vme-registers $module.*

    inform fsys FAIR_DAQ-halt
}

proc {FAIR SYSC_DAQ-setup} {args} {
#   FAIR system
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

#    initialise
    initialise-vme-registers $module.*

    inform fsysc FAIR_Initialise
    inform fsysc FAIR_DAQ-setup
}

proc {FAIR SYSC_DAQ-halt} {args} {
#   FAIR system
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

    inform fsysc FAIR_DAQ-halt
}

proc {FAIR SYSC_DAQ-go} {args} {
#   FAIR system
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

    inform fsysc FAIR_DAQ-go
}



